close all
clear all
%Read:
run ReadResults.m
%Plot the results:
%Labels related to the results:
% Force  X Y Z MX MY MZ
% Position X Y Z Xrot Yrot Zrot
% Velocity ----II----
% Acceleration ----II----
% ThForce MX MY MZ Tbp Tbs Tfp Tfs X Y Z
% DynParam 24, see ReadResults.m
% ROV Maxi Midi Mini
% Depth -10m, -20m
% Gains Kp1 Kp2 Kp3 Kd1 Kd2 Kd3 Ki1 Ki2 Ki3
% l 1,2 no of depths
% i Case 1:7
% k ROV 1:3
% j,o,s = DOF 1:6
% m,p = 1:9 (thruster)
% n,q = 1:24 Dynamic Pos Paramters
% r tuning cases 1:7
% t number of tuning gains 1:9
% Wave elevation WaveEl(1,1:2000,1:7,1:3,1:2)
% Significant wave height Hs(1:7,1:3,1:2)
% Peak Period Tp(1:7,1:3,1:2)
% 1st order wave force FOWL(1:6,1:2000,1:7,1:3,1:2)
% Quadratic damping force QDF(1:6,1:2000,1:7,1:3,1:2)
% Linear damping force LDF(1:6,1:2000,1:7,1:3,1:2)
% Stiffness force SF(1:6,1:2000,1:2000,1:7,1:3,1:2)
% Total forces TOTF(1:6,1:2000,1:7,1:3,1:2)
% Global position POS(1:6,1:2000,1:7,1:3,1:2)
% Local velocity VEL(1:6,1:2000,1:7,1:3,1:2)
% Acceleration ACC(1:6,1:2000,1:7,1:3,1:2)
% Thruster forces THFORCE(1:9,1:2000,1:7,1:3,1:2)
% Dyn pos parameters DYNPARAM(1:24,1:2000,1:7,1:3,1:2)
% Kalman filter GAINS(1:9,1:7) 
% Glo pos. when tuning POSTUNE(1:6,1:2000,1:7)


% WaveEl(1,:,i,k,l)
% Hs(i,k,l)
% Tp(i,k,l)
% FOWL(j,:,i,k,l)
% QDF(j,:,i,k,l)
% LDF(j,:,i,k,l)
% SF(j,:,i,k,l)
% TOTF(j,:,i,k,l)
% POS(j,:,i,k,l)
% VEL(j,:,i,k,l)
% ACC(j,:,i,k,l)
% THFORCE(m,:,i,k,l)
% DYNPARAM(n,:,i,k,l)
% 
% GAINS(k,r) 
% POSTUNE(s,:,r)
a = 0;
%Plots of the wave elevation:
for i =1:7
a = a+1;
figure(a)
Timea = Time(1:4000);
plot(Timea,WaveEl(1,1:length(Timea),a,1,1),'b',Timea,zeros(1,length(Timea)),'k-');
xlabel('Time [s]');
ylabel('The wave elevation, \zeta  [m]');

title(sprintf('Case %d: H_s = %.1f m, T_p = %.1f s',i, Hs(i,1,1),Tp(i,1,1)));
set(a, 'units', 'centimeters', 'pos', [0 0 15 5.67])
set(a,'PaperPositionMode','auto')
axis([min(Timea) max(Timea) -2 2])
file = sprintf('WaveCase%d',a);
saveas(a, file, 'png');
hold off
end
%Plots of position for each case and each ROV and each depth.
DOF = cellstr(['Surge';
               'Sway ';
               'Heave';
               'Roll ';
               'Pitch';
               'Yaw  ';]);
DIM = cellstr(['[m]       ';'[m]       ';'[m]       ';'[^{\circ}]';'[^{\circ}]';'[^{\circ}]']);           
rangeMax = [3.8, 5, 0, 0, 0, 35];
rangeMin = [1, 0.5, 0, 0, 0, 17];
desired = [2 4 0 0 0 15];
Hs0= cellstr('Calm');
Tp0 = cellstr('Sea');
count=0;
Timea = Time(1:4000);
Col= cellstr(['r';'b';'g']);
for l = 1:2;
    CurrDepth = Depth(l);
    for i =1:8;
        count=0;
        a = a+1;
        figure(a)
        for m = [1,2,6];
            count=count+1;         
            subplot(3,1,count)
            plot(Timea,ones(1,length(Timea))*desired(m),'k-')
            hold on
            for k = 1:3;
                CurrROV = char(ROV(k));  
                plot(Timea,POS(m,1:length(Timea),i,k,l),char(Col(k)));                                  
                
           
                hold on                
            end
            if m==2;
                legend('Desired','MaxiROV','MidiROV','MiniROV','Location','NorthEastOutside');
                hold on
            end
            grid on
            axis([min(Timea) max(Timea) -1*rangeMin(m) 1*rangeMax(m)])
            xlabel('Time [s]');
            ylabel(sprintf('%s Displacement %s', char(DOF(m)),char(DIM(m))));
            
            
        end
        
        if i<8;
            mtit(sprintf('Case %d: H_s = %.1f m, T_p = %.1f s at Depth z = -%d m',i, Hs(i,1,1),Tp(i,1,1),CurrDepth))
            hold on
        else 
            mtit(sprintf('Case %d: %s %s at Depth z = -%d m',i, char(Hs0),char(Tp0),CurrDepth));
            hold on
        end
        set(a, 'units', 'centimeters', 'pos', [0 0 15 40])
        set(a,'PaperPositionMode','auto')
       
        file = sprintf('Case%dDepth%d.tif',i,CurrDepth);
        print(a,'-dtiff', file);
        hold off
    end
end


%Plot x vs y position:

for l = 1:2
    CurrDepth = Depth(l);
    for i =1:8
        a = a+1;
        figure(a)
         for k = 1:3;
                CurrROV = char(ROV(k));  
                plot(POS(1,1:2000,i,k,l),POS(2,1:2000,i,k,l),char(Col(k)))
                hold on
                 
                
                 
                if i<8;
                    mtit(sprintf('Case %d: H_s = %.1f m, T_p = %.1f s at Depth z = -%d m',i, Hs(i,1,1),Tp(i,1,1),CurrDepth))
                    hold on
                else 
                    mtit(sprintf('Case %d: %s %s at Depth z = -%d m',i, char(Hs0),char(Tp0),CurrDepth));
                    hold on
                end
         end
         axis([-1.0 4 -0.5 4.5])
         grid on
         %set(a, 'units', 'centimeters', 'pos', [0 0 15 15])
         
         set(a,'PaperPositionMode','auto')
         legend('MaxiROV','MidiROV','MiniROV','Location','SouthEast');
         hold on
         file = sprintf('XYCase%dDepth%d.png',i,CurrDepth);
         print(a,'-dpng', file);
         hold off
    end
end

%Plot tuning procedure
rangeMax = [3, 5, 0, 0, 0, 23];
rangeMin = [1, 0.5, 0, 0, 0, 2.5];

count = 1;
count4 = [4,1,7];
Gains = cellstr(['K_d';'K_p';'K_i']);
Timea = Time(1:2000);
m = [1,2,6];
for i =1:3;
    
    count = count+1;
    CurrGains = [GAINS(:,1) GAINS(:,count)];
    count = count+1;
    CurrGains = [CurrGains GAINS(:,count)];
    a = a+1;
    figure(a)
    
    
    CurrGain =(char(Gains(i)));
    for j = 1:3;
        subplot(3,1,j)
        plot(Timea,ones(1,length(Timea))*desired(m(j)),'k-')
        hold on
        plot(Timea,POSTUNE(m(j),1:length(Timea),1),char(Col(1)))
        hold on
         
        plot(Timea,POSTUNE(m(j),1:length(Timea),count-1),char(Col(2)));
        hold on
        plot(Timea,POSTUNE(m(j),1:length(Timea),count),char(Col(3)));
        hold on     
%         count4(count3)
%         CurrGains(count4(count1),1)
%         CurrGains(count4(count1)+1,2)
%         CurrGains(count4(count1)+1,3)
        legend('Desired',...
            sprintf('%s^%d = %.3f',CurrGain,m(j),CurrGains(count4(i)+j-1,1)),...
            sprintf('%s^%d = %.3f',CurrGain,m(j),CurrGains(count4(i)+j-1,2)),...
            sprintf('%s^%d = %.3f',CurrGain,m(j),CurrGains(count4(i)+j-1,3)),...
            'Location','SouthEast');
        hold on
        grid on
        if j ==1;
            title(sprintf('Tuning of %s, Case 8: %s %s',CurrGain, char(Hs0),char(Tp0)));
            hold on
        end
        if i ==3;
            rangeMax = [3, 5, 0, 0, 0, 185];
            rangeMin = [7, 7, 0, 0, 0, 185];
        end
        axis([min(Timea) max(Timea) -1*rangeMin(m(j)) 1*rangeMax(m(j))])
        xlabel('Time [s]');
        ylabel(sprintf('%s Displacement %s', char(DOF(m(j))),char(DIM(m(j)))));


    end
    
    hold on
    set(a, 'units', 'centimeters', 'pos', [0 0 15 45])
    set(a,'PaperPositionMode','auto')

    file = sprintf('Tuning%s.tif',CurrGain);
    print(a,'-dtiff', file);
    hold off
end
    
