clear all
close all
[ freq, RAOamplitude, RAOphase, RAOidir, RAOifreq, FOWFamplitude,...
    FOWFphase]= ReadResultsW('sysMaxi.txt');

[ freq, RAOamplitude(:,:,2), RAOphase(:,:,2), RAOidir, RAOifreq,...
    FOWFamplitude(:,:,2),FOWFphase(:,:,2)]...
    = ReadResultsW('sysMidi.txt');


[ freq, RAOamplitude(:,:,3), RAOphase(:,:,3), RAOidir, RAOifreq,...
    FOWFamplitude(:,:,3),FOWFphase(:,:,3)]...
    = ReadResultsW('sysMini.txt');

RAOamp = zeros(55,24,6,3);RAOph = RAOamp;FOWFamp = RAOamp;FOWFph =RAOamp; 
for h = 0:23
    start=(55*h+1);
    RAOamp(1:55,h+1,:,:) = RAOamplitude(start:start+54,:,:);
    RAOph(1:55,h+1,:,:) = RAOphase(start:start+54,:,:);
    FOWFamp(1:55,h+1,:,:) = FOWFamplitude(start:start+54,:,:);
    FOWFph(1:55,h+1,:,:) = FOWFphase(start:start+54,:,:);
end

TFamp = RAOamp;
TFamp(1:55,1:24,1:6,1:3,2) = FOWFamp;
TFamp(1:55,1:24,4:6,1:3,1) = TFamp(1:55,1:24,4:6,1:3,1).*(180/pi);
TFamp(1:55,1:24,1:6,1:3,2) = TFamp(1:55,1:24,1:6,1:3,2).*1000;
TFph = RAOph;
TFph(1:55,1:24,1:6,1:3,2) = FOWFph;

run AddedMassandPotDampRet.m

 DIM = cellstr(['kg   ';
         'kg   ';   
         'kg   ';
         'kgm^2';
         'kgm^2';
         'kgm^2';
         'kgm  ';
         'kgm  ';
         'kgm  ';
         'kgm  ']);
 DIM = [DIM cellstr(['Ns/m';
         'Ns/m';   
         'Ns/m';
         'Nsm ';
         'Nsm ';
         'Nsm ';
         'Ns  ';
         'Ns  ';
         'Ns  ';
         'Ns  '])];
 DIM = [DIM cellstr(['N/m';
         'N/m';
         'N/m';
         'Nm ';
         'Nm ';
         'Nm ';
         'N  ';
         'N  ';
         'N  ';
         'N  '])];
 ROV = cellstr(['Maxi';
                'Midi';
                'Mini']);
 DOF = [11,22,33,44,55,66,15,24,42,51];
 ABR = cellstr([ 'A';'B';'K']);
 
 xlab = cellstr(['Frequency rad/s';
                 'Frequency rad/s';
                 'Time s         ']);
 ABRfunc = AddMass;
 ABRfunc(:,:,:,2) = PotDamp;
 ABRfunc(:,:,:,3) = Ret;
 
funcname = cellstr(['Added Mass           ';
                    'Potential Damping    ';
                    'Retardaation Function']);
                
Col= cellstr(['r-';'b-';'g-']); 
b = [1 1 1 2 2 2 3 3 3 4]; c = [1 2 3 1 2 3 1 2 3 2];

Xlength(1:2,1:10,1:3) = length(freq);
Xlength(3,1:10,1) = RetN(1,:);
Xlength(3,1:10,2) = RetN(2,:);
Xlength(3,1:10,3) = RetN(3,:);
a=0;
N = max(max(max(Xlength)))-1;
dt = 0.1;
timeb = (0:dt:N*dt)';
Xaxis = [freq freq timeb];
%Plot added mass, pot damping, retardation
 for j = 1:3;
     Currfunc = char(ABR(j));
     a = a+1;
     figure(a)
     for i = 1:10
         if i==10;
             subplot(4,3,11)
         else
             subplot(4,3,i)
         end
         hold on
             maxY = max(max(ABRfunc(1:max(Xlength(j,i,1:3)),i,1:3,j)));
             minY = min(min(ABRfunc(1:max(Xlength(j,i,1:3)),i,1:3,j)));
         for k = 1:3;
             CurrROV = char(ROV(k));  
             lengthXaxis = Xlength(j,i,k);
             plot(Xaxis(1:40,j), ABRfunc(1:40,i,k,j),char(Col(k))); 

             maxX = max(Xaxis(1:40,j));
             minX = 0;
             axis([minX ceil(maxX) 1.02*minY 1.02*maxY])
             hold on  
         end
         if i==10;
             legend('MaxiROV','MidiROV','MiniROV','Location','NorthEastOutside');
             hold on
         end
         grid on         
         xlabel(char(xlab(j)));
         title(sprintf('%s%d [%s]',char(ABR(j)), (DOF(i)),char(DIM(i,j))));  
     end
     
     hold on     
     set(a, 'units', 'centimeters', 'pos', [0 0 15 20])
     set(a,'PaperPositionMode','auto')     
     file = sprintf('%s.tif',char(funcname(j)));
     print(a,'-dtiff', file);
     hold off
 end
 %Plot RAO and first order wave force
 funcname = cellstr(['First Order Motion Transfer Function    ';
                     'First Order Wave Force Transfer Function']);
 filename = cellstr(['Firstordermotion';
                     'Firstorderforce ']);
 clear DIM
 DIM = cellstr(['m/m  '; 
                'm/m  ';
                'm/m  ';
                'deg/m';
                'deg/m';
                'deg/m']);
 DIM = [DIM cellstr(['N/m ';
                     'N/m ';   
                     'N/m ';
                     'Nm/m';
                     'Nm/m';
                     'Nm/m'])];
 Col= cellstr(['r-';'b-';'c-';'m-';'g-']);
 DOF = cellstr(['Surge';
                'Sway ';
                'Heave';
                'Roll ';
                'Pitch';
                'Yaw  ']);
leg1 = cellstr(['\beta = ';
                '^\circ  ']) ;
for f = 0:4
    CurrDIR = f*45;
    iDIR = 3*f+1;
    for j = 1:3; % 1 = maxi, 2 = Midi, 3 = Maxi
        CurrROV = char(ROV(j));      
          for l = 1:2; %1 RAO, 2 FOWF
              currFUNC = char(funcname(l));
              for g = 1:2; %1 =DOF 1-3, 2 = DOF 5-6
                  a = a+1;
                  figure(a)
                  for i = 1:3                 
                      CurrDOF = char(DOF(3*(g-1)+i));
                      CurrDIM = char(DIM(3*(g-1)+i,l));
                      %Plot amplitudes
                      subplot(2,3,i)
                      hold on
                      maxY = max(max(TFamp(:,iDIR,3*(g-1)+i,j,l)));
                      minY = min(min(TFamp(:,iDIR,3*(g-1)+i,j,l)));

                      if maxY>0&&minY<0
                          minY = 1.02*minY;
                          maxY = 1.02*maxY;
                      elseif maxY>0&&minY>0
                          minY = 0.98*minY;
                          maxY = 1.02*maxY;
                          if minY<1e-3;
                              minY = 0;
                          end
                      elseif maxY<0&&minY<0
                          minY = 1.02*minY;
                          maxY = 0.98*maxY;                  
                      end
                      if maxY==0 && minY==0;
                          maxY = 10;
                          minY = -10;
                      end
                      plot(freq,TFamp(:,iDIR,3*(g-1)+i,j,l),char(Col(f+1))); 
                      hold on  

                      xlabel('Frequency rad/s');
                      ylabel(sprintf('Amplitude %s',CurrDIM));
                      axis([min(freq) max(freq) minY maxY])
                      title(sprintf('%s',CurrDOF),'fontsize',9);
                      if i ==2&&g==1;
                          leg = [char(leg1(1)) sprintf(' %d',CurrDIR) char(leg1(2))];
                          legend(leg,...%'\beta = 45 ^\circ','\beta = 90 ^\circ','\beta = 135 ^\circ','\beta = 180 ^\circ',
                              'Location','SouthOutside',...
                              'Orientation','horizontal');
                          hold on
                      end
                      grid on
                      hold on
                  end

                  for m = 1:3                  
                      %Plot phases
                      CurrDOF = char(DOF(3*(g-1)+m));
                      subplot(2,3,3+m)
                      hold on
                      maxY = max(max(TFph(:,iDIR,3*(g-1)+m,j,l)));
                      minY = min(min(TFph(:,iDIR,3*(g-1)+m,j,l)));

                      if maxY>0&&minY<0
                          minY = 1.02*minY;
                          maxY = 1.02*maxY;
                      elseif maxY>0&&minY>0
                          minY = 0.98*minY;
                          maxY = 1.02*maxY;
    %                       if minY<1e-3;
    %                           minY = 0;
    %                       end
                      elseif maxY<0&&minY<0
                          minY = 1.02*minY;
                          maxY = 0.98*maxY;                  
                      end
                      if maxY==0 && minY==0;
                          maxY = 10;
                          minY = -10;
                      end 

                      plot(freq,TFph(:,iDIR,3*(g-1)+m,j,l),char(Col(f+1))); 
                      hold on

                      xlabel('Frequency rad/s');
                      ylabel('Phase deg'); 
                      axis([min(freq) max(freq) -200 200])

                      grid on
                      hold on  
                  end


                  hold on
                  if g==1;
                  mtit(sprintf('%s, %sROV',currFUNC,CurrROV),'fontsize',11,'xoff',-.01,'yoff',.029);
                  end
                  set(a, 'units', 'centimeters', 'pos', [0 0 16 14])
                  set(a,'PaperPositionMode','auto') 
                  file = sprintf('%s%s%ddeg%d.PNG',char(filename(l)),CurrROV,CurrDIR,g);
                  print(a,'-dpng', file);
                  hold off
              end         
          end
    end
end
 
 
 
 