clear all 
Time = 0:0.1:1999.9;
%Read all the results for all ROVS

Force = cellstr(['XRforce      ';
                 'YRforce      ';
                 'ZRforce      ';
                 'Moment_XRaxis';
                 'Moment_YRaxis';
                 'Moment_ZRaxis']);
Position = cellstr(['XGtranslationTotalmotion';
                    'YGtranslationTotalmotion';
                    'ZGtranslationTotalmotion';
                    'XLrotationTotalmotion   ';
                    'YLrotationTotalmotion   ';
                    'ZGrotationTotalmotion   ';]);
Velocity = cellstr(['XLvelocityTotalmotion';
                    'YLvelocityTotalmotion';
                    'ZLvelocityTotalmotion';
                    'XLang_vel_Totalmotion';
                    'YLang_vel_Totalmotion';
                    'ZLang_vel_Totalmotion']);
Acceleration = cellstr(['DDt_Euler_XangTotalmotion'; 
                        'DDt_Euler_YangTotalmotion';
                        'DDt_Euler_ZangTotalmotion'; 
                        'XGaccelerationTotalmotion'; 
                        'YGaccelerationTotalmotion'; 
                        'ZGaccelerationTotalmotion']);
ThForce = cellstr(['Moment_XBaxis_total';
                   'Moment_YBaxis_total';
                   'Moment_ZBaxis_total';
                   'Tbp_Force          ';
                   'Tbs_Force          ';
                   'Tfp_Force          ';
                   'Tfs_Force          ';
                   'XBforce_total      ';
                   'YBforce_total      ';
                   'ZBforce_total      ';]);
DynParam = cellstr(['Biasmomentest_            '; 
                    'GlobalLFXpositionest_     '; 
                    'GlobalLFXvelocityest_     '; 
                    'GlobalLFYpositionest_     '; 
                    'GlobalLFYvelocityest_     '; 
                    'GlobalXcurrentest_        '; 
                    'GlobalYcurrentest_        '; 
                    'HFsurgefrequencyest_      '; 
                    'HFsurgepositionest_       '; 
                    'HFsurgevelocityest_       '; 
                    'HFswayfrequencyest_       '; 
                    'HFswaypositionest_        '; 
                    'HFswayvelocityest_        '; 
                    'HFyawest_                 '; 
                    'HFyawfrequencyest_        '; 
                    'HFyawvelocityest_         '; 
                    'Headingerrorest_          '; 
                    'Headingestimationerrorest_'; 
                    'LFheadingest_             '; 
                    'LFheadingvelocityest_     '; 
                    'Surgeestimationerrorest_  '; 
                    'Surgepositioningerrorest_ '; 
                    'Swayestimationerrorest_   '; 
                    'Swaypositioningerrorest_  ']);               
ROV = cellstr(['Maxi';'Midi';'Mini']);
Depth = [10, 20];
for l = 1:2;
    CurrDepth = Depth(l);
    for k = 1:3;
        CurrROV = char(ROV(k));
        Fid = sprintf('%sCase%d.HDF5',CurrROV,CurrDepth);
        for i = 1:7;
            %7 different cases within Rataren Environment
            %Read wave elevation:
            S = sprintf('/%s45m/Case%d/Case%d_%d/Dynamic/%sROV/Wave elevation/Totalwaveelevation',CurrROV,CurrDepth,CurrDepth,i,CurrROV);
            WaveEl(1,:,i,k,l)=h5read(Fid,S);
            %Read sea state:
            S = sprintf('/%s45m/Case%d/Case%d_%d/Variables/Hs',CurrROV,CurrDepth,CurrDepth,i);
            Hs(i,k,l) = h5read(Fid,S);
            S = sprintf('/%s45m/Case%d/Case%d_%d/Variables/Tp',CurrROV,CurrDepth,CurrDepth,i);
            Tp(i,k,l) = h5read(Fid,S);
            %Read all files with six timeseries(Xtr,Ytr,Ztr,Xrot,Yrot,Zrot).
            for j = 1:6; 
                %Read First order wave loads:
                CurrDOF = char(Force(j));
                S = sprintf('/%s45m/Case%d/Case%d_%d/Dynamic/%sROV/1st order wave force/%s',CurrROV,CurrDepth,CurrDepth,i,CurrROV,CurrDOF);
                FOWL(j,:,i,k,l)=h5read(Fid,S);
                %Read Quadratic damping forces:
                CurrDOF = char(Force(j));
                S = sprintf('/%s45m/Case%d/Case%d_%d/Dynamic/%sROV/Quadratic damping force/%s',CurrROV,CurrDepth,CurrDepth,i,CurrROV,CurrDOF);
                QDF(j,:,i,k,l)=h5read(Fid,S);
                %Read Linear damping forces:
                S = sprintf('/%s45m/Case%d/Case%d_%d/Dynamic/%sROV/Linear damping force/%s',CurrROV,CurrDepth,CurrDepth,i,CurrROV,CurrDOF);
                LDF(j,:,i,k,l)=h5read(Fid,S);
                %Read Stiffness forces:
                S = sprintf('/%s45m/Case%d/Case%d_%d/Dynamic/%sROV/Stiffness force/%s',CurrROV,CurrDepth,CurrDepth,i,CurrROV,CurrDOF);
                SF(j,:,i,k,l)=h5read(Fid,S);
                %Read Total forces:
                S = sprintf('/%s45m/Case%d/Case%d_%d/Dynamic/%sROV/Total force/%s',CurrROV,CurrDepth,CurrDepth,i,CurrROV,CurrDOF);
                TOTF(j,:,i,k,l)=h5read(Fid,S);
               
                %Read position of ROV:
                CurrDOF = char(Position(j));
                S = sprintf('/%s45m/Case%d/Case%d_%d/Dynamic/%sROV/Global pos. (time domain)/%s',CurrROV,CurrDepth,CurrDepth,i,CurrROV,CurrDOF);
                POS(j,:,i,k,l)=h5read(Fid,S);
                %Read velocity of ROV:
                CurrDOF = char(Velocity(j));
                S = sprintf('/%s45m/Case%d/Case%d_%d/Dynamic/%sROV/Local velocity/%s',CurrROV,CurrDepth,CurrDepth,i,CurrROV,CurrDOF);
                VEL(j,:,i,k,l)=h5read(Fid,S);
                %Read acceleration of ROV:
                CurrDOF = char(Acceleration(j));
                S = sprintf('/%s45m/Case%d/Case%d_%d/Dynamic/%sROV/Global acceleration/%s',CurrROV,CurrDepth,CurrDepth,i,CurrROV,CurrDOF);
                ACC(j,:,i,k,l)=h5read(Fid,S);
            end
            %Read files with 6 timeseries
            for m = 1:10;
                %Read thruster and thrust forces of ROV:
                CurrDOF = char(ThForce(m));
                S = sprintf('/%s45m/Case%d/Case%d_%d/Dynamic/%sROV/Thruster force/%s',CurrROV,CurrDepth,CurrDepth,i,CurrROV,CurrDOF);
                THFORCE(m,:,i,k,l)=h5read(Fid,S);                
            end
            %Read files with 24 timeseries
            for n = 1:24;
                CurrDOF = char(DynParam(n));
                S = sprintf('/%s45m/Case%d/Case%d_%d/Dynamic/%sROV/Dynamic positioning parameters/%s',CurrROV,CurrDepth,CurrDepth,i,CurrROV,CurrDOF);
                DYNPARAM(n,:,i,k,l)=h5read(Fid,S);
            end
        end
        %READ CALM SEA CASES:
        Fid = sprintf('%sCaseCalm1020.HDF5',CurrROV);
        for o = 1:6; 
            %There are no First order wave loads:
            %Read Quadratic damping forces:
            CurrDOF = char(Force(o));
            S = sprintf('/%s45m/CalmSea1020/CalmSea1020_%d/Dynamic/%sROV/Quadratic damping force/%s',CurrROV,l,CurrROV,CurrDOF);
            QDF(o,:,8,k,l)=h5read(Fid,S);
            %Read Linear damping forces:
            S = sprintf('/%s45m/CalmSea1020/CalmSea1020_%d/Dynamic/%sROV/Linear damping force/%s',CurrROV,l,CurrROV,CurrDOF);
            LDF(o,:,8,k,l)=h5read(Fid,S);
            %Read Stiffness forces:
            S = sprintf('/%s45m/CalmSea1020/CalmSea1020_%d/Dynamic/%sROV/Stiffness force/%s',CurrROV,l,CurrROV,CurrDOF);
            SF(o,:,8,k,l)=h5read(Fid,S);
            %Read Toal forces:
            S = sprintf('/%s45m/CalmSea1020/CalmSea1020_%d/Dynamic/%sROV/Total force/%s',CurrROV,l,CurrROV,CurrDOF);
            TotF(o,:,8,k,l)=h5read(Fid,S);
            %Read position of ROV:
            CurrDOF = char(Position(o));
            S = sprintf('/%s45m/CalmSea1020/CalmSea1020_%d/Dynamic/%sROV/Global pos. (time domain)/%s',CurrROV,l,CurrROV,CurrDOF);
            POS(o,:,8,k,l)=h5read(Fid,S);
            %Read velocity of ROV:
            CurrDOF = char(Velocity(o));
            S = sprintf('/%s45m/CalmSea1020/CalmSea1020_%d/Dynamic/%sROV/Local velocity/%s',CurrROV,l,CurrROV,CurrDOF);
            VEL(o,:,8,k,l)=h5read(Fid,S);
            %Read acceleration of ROV:
            CurrDOF = char(Acceleration(o));
            S = sprintf('/%s45m/CalmSea1020/CalmSea1020_%d/Dynamic/%sROV/Global acceleration/%s',CurrROV,l,CurrROV,CurrDOF);
            VEL(o,:,8,k,l)=h5read(Fid,S);
        end
        %Read files with 6 timeseries
        for p = 1:9;
            %Read thruster and thrust forces of ROV:
            CurrDOF = char(ThForce(p));
            S = sprintf('/%s45m/CalmSea1020/CalmSea1020_%d/Dynamic/%sROV/Thruster force/%s',CurrROV,l,CurrROV,CurrDOF);
            THFORCE(p,:,8,k,l)=h5read(Fid,S);                
        end
        %Read files with 24 timeseries
        for q = 1:24;
            CurrDOF = char(DynParam(q));
            S = sprintf('/%s45m/CalmSea1020/CalmSea1020_%d/Dynamic/%sROV/Dynamic positioning parameters/%s',CurrROV,l,CurrROV,CurrDOF);
            DYNPARAM(q,:,8,k,l)=h5read(Fid,S);
        end
    end
end

%Read results from tuning:

Fid = 'MaxiTuningPID.HDF5';
Gains = cellstr(['Kp1';
                 'Kp2';
                 'Kp3';
                 'Kd1';
                 'Kd2';
                 'Kd3';
                 'Ki1';
                 'Ki2';
                 'Ki3']);
                     
for r = 1:7; 
    for t =1:9;
        gain = char(Gains(t));
        S = sprintf('/Maxi45m/TuningPID/TuningPID_%d/Variables/%s',r,gain);
        GAINS(t,r) = h5read(Fid,S);
    end
    for s = 1:6;
        %Read position of ROV:
        CurrDOF = char(Position(s));
        S = sprintf('/Maxi45m/TuningPID/TuningPID_%d/Dynamic/MaxiROV/Global pos. (time domain)/%s',r,CurrDOF);
        POSTUNE(s,:,r)=h5read(Fid,S);
    end
    
end

%MidiROV results:
% '/Midi45m/Case10/Case10_1/Dynamic/MidiROV/Global pos. (time domain)' 
%                             Dataset 'XGtranslationTotalmotion' 
%                             Dataset 'XLrotationTotalmotion' 
%                             Dataset 'YGtranslationTotalmotion' 
%                             Dataset 'YLrotationTotalmotion' 
%                             Dataset 'ZGrotationTotalmotion' 
%                             Dataset 'ZGtranslationTotalmotion' 


%MiniROV results:
