
function [ freq, RAOamplitude, RAOphase, RAOidir, RAOifreq, FOWFamplitude,...
    FOWFphase]= ReadResultsW(file)
%Read transferfunction results:

fid = fopen(file,'r');

dummytxt = textscan(fid,'%s',64806,'delimiter','\n');
clear dummytext
%read direction set:
dir = fscanf(fid,'%d %f',[2 24])';
dir = dir(:,2);
%read frequency set:
dummytxt = textscan(fid,'%s',5,'delimiter','\n');
clear dummytext
freqA = fscanf(fid,'%d %f',[2 55])';
freq = freqA(:,2);
per = flipud(2*pi./freq);
%read motion transfer functions
dummytxt = textscan(fid,'%s',5,'delimiter','\n');
RAOamplitude = zeros(1320,6);
RAOphase = zeros(1320,6);

for i = 1:6
    clear dummytext;
    TF = fscanf(fid,'%d %d %f %f',[4 1320])';
    RAOamplitude(:,i) = TF(:,3);
    RAOphase(:,i) = TF(:,4);
    dummytxt = textscan(fid,'%s',5,'delimiter','\n');
end

RAOidir = TF(:,1);
RAOifreq = TF(:,2);
clear dummytxt;

%read first order wave force transver functions
dummytxt = textscan(fid,'%s',94,'delimiter','\n');
FOWFamplitude = zeros(1320,6);
FOWFphase = zeros(1320,6);
for j = 1:6
    clear dummytxt;
    TF = fscanf(fid,'%d %d %f %f',[4 1320])';
    FOWFamplitude(:,j) = TF(:,3);
    FOWFphase(:,j) = TF(:,4);
    dummytxt = textscan(fid,'%s',5,'delimiter','\n');
end

FOWFidir = TF(:,1);
FOWFifreq = TF(:,2);
clear dummytxt;


fclose(fid);
end